apiVersion: cert-manager.io/v1
kind: Certificate
metadata:
  name: kibana-tls
  namespace: svc-elasticsearch
spec:
  # Secret names are always required.
  secretName: kibana-tls
  duration: 2160h # 90d
  renewBefore: 360h # 15d
  # subject:
  #   organizations:
  #     - WTBT
  # The use of the common name field has been deprecated since 2000 and is
  # discouraged from being used.
  commonName: kibana.service.wtbt.uk
  isCA: false
  privateKey:
    algorithm: RSA
    encoding: PKCS1
    size: 2048
  usages:
    - server auth
    - client auth
  # At least one of a DNS Name, URI, or IP address is required.
  dnsNames:
    - kibana.service.wtbt.uk
  # uris:
  #   - spiffe://cluster.local/ns/sandbox/sa/example
  # ipAddresses:
  #   - 192.168.0.5
  # Issuer references are always required.
  issuerRef:
    name: cluster-ca
    # We can reference ClusterIssuers by changing the kind here.
    # The default value is Issuer (i.e. a locally namespaced Issuer)
    kind: ClusterIssuer
    # This is optional since cert-manager will default to this value however
    # if you are using an external issuer, change this to that issuer group.
---
apiVersion: traefik.containo.us/v1alpha1
kind: Middleware
metadata:
  name: test-passtlsclientcert
  namespace: svc-elasticsearch
spec:
  passTLSClientCert:
    pem: true
    info:
      subject:
        commonName: true
---
apiVersion: traefik.containo.us/v1alpha1
kind: Middleware
metadata:
  name: test-forwardauth
  namespace: svc-elasticsearch
spec:
  forwardAuth:
    address: http://localhost:3001/verify
---
apiVersion: traefik.io/v1alpha1
kind: Middleware
metadata:
  name: test-chain
  namespace: svc-elasticsearch
spec:
  chain:
    middlewares:
    - name: test-passtlsclientcert
    - name: test-forwardauth
---
apiVersion: traefik.containo.us/v1alpha1
kind: ServersTransport
metadata:
  name: skipverify
  namespace: svc-elasticsearch
spec:
  insecureSkipVerify: true
---
apiVersion: traefik.containo.us/v1alpha1
kind: IngressRoute
metadata:
  name: kibana
  namespace: svc-elasticsearch
spec:
  entryPoints:
    - web
    - websecure
  routes:
    - match: Host(`kibana.service.wtbt.uk`)
      kind: Rule
      services:
        - name: kb-kb-http
          namespace: svc-elasticsearch
          serversTransport: skipverify
          port: https
          kind: Service
      middlewares:
        - name: test-chain
  tls:
    secretName: kibana-tls         # [13]
    options:                        # [14]
      name: user-ca
      namespace: svc-ingress
    # certResolver: foo               # [17]
    domains:                        # [18]
    - main: kibana.service.wtbt.uk             # [19]
      # sans:                         # [20]
      # - a.example.net
      # - b.example.net
